//
//	joystick.cpp	: WCXeBbNvO
//
//

#include <math.h>
#include <stdio.h>
#include "mfjundatta.h"

class CJoyJundatta : public CMfJundatta
{
private:
	CMfBits	m_Layer;	// eLXg
	short	m_FontW;	// tHg̕
	short	m_FontH;	// tHg̍
	
public:
	bool OnCreate( void );
	void OnDestroy( void );
	void OnUpdate( void );
	void OnJoystick( const DIJOYSTATE *pJs );
};


/*==================================================================*
 +
 +	MfStartupJundatta	: AvP[VX^[gAbv
 +
 +==================================================================*/
CMfJundatta *MfStartupJundatta( void )
{
	static CJoyJundatta	sJoyJundatta;
	char strCaption[80];
	sprintf( &strCaption[0], "WCXeBbNvO(200%s)", CMfJundatta::Version() );
	if ( sJoyJundatta.Create( &strCaption[0], false ) == false )	return( NULL );
	return( &sJoyJundatta );
}
bool CJoyJundatta::OnCreate( void )
{
// eLXgʂ̍쐬
	m_Layer.Startup( kMfScreenW, kMfScreenH );
	m_Layer.Clear( 0, 0, 0, 255 );
	CGrafPtr pGraf;
	GDHandle hDev;
	::GetGWorld( &pGraf, &hDev );
	::SetGWorld( m_Layer.m_pGWorld, NULL );
	// tHg̐ݒ
	FMFontFamily theFontID = ::FMGetFontFamilyFromName( "\pOsaka" );
	::TextFont( theFontID );
	// F
	RGBColor fc;
	fc.red = 0xffff;
	fc.green = 0xffff;
	fc.blue = 0xffff;
	::RGBForeColor( &fc );
	// ̃TCYo
	FontInfo fi;
	::GetFontInfo( &fi );
	m_FontW = fi.widMax;
	m_FontH = fi.ascent + fi.descent;
	::SetGWorld( pGraf, hDev );

	glDisable( GL_DEPTH_TEST );	// [xobt@O
	return true;
}
void CJoyJundatta::OnDestroy( void )
{
	// eLXgʂ̔j
	m_Layer.Cleanup();
}
void CJoyJundatta::OnUpdate( void )
{
	m_Layer.Update();
}
void CJoyJundatta::OnJoystick( const DIJOYSTATE *pJs )
{
	// ܂AsŉʑŜNA
	m_Layer.Clear( 0, 0, 0, 255 );

	CGrafPtr pGraf;
	GDHandle hDev;
	::GetGWorld( &pGraf, &hDev );
	::SetGWorld( m_Layer.m_pGWorld, NULL );

	short h = m_FontH;
	char cStr[256];
	unsigned char Msg[256];
// Joystick̏
	::MoveTo( m_FontW, h );
	sprintf( &cStr[0], "WCXeBbN̏" );
	::c2pstrcpy( &Msg[0], &cStr[0] );
	::DrawString( &Msg[0] );
// X
	h += m_FontH;
	::MoveTo( m_FontW, h );
	sprintf( &cStr[0], "lX = %ld", pJs->lX );
	::c2pstrcpy( &Msg[0], &cStr[0] );
	::DrawString( &Msg[0] );
// Y
	h += m_FontH;
	::MoveTo( m_FontW, h );
	sprintf( &cStr[0], "lY = %ld", pJs->lY );
	::c2pstrcpy( &Msg[0], &cStr[0] );
	::DrawString( &Msg[0] );
// XeBbNZ]
	h += m_FontH;
	::MoveTo( m_FontW, h );
	sprintf( &cStr[0], "lRz = %ld", pJs->lRz );
	::c2pstrcpy( &Msg[0], &cStr[0] );
	::DrawString( &Msg[0] );
// V_
	h += m_FontH;
	::MoveTo( m_FontW, h );
	sprintf( &cStr[0], "rglSlider[0] = %ld", pJs->rglSlider[0] );
	::c2pstrcpy( &Msg[0], &cStr[0] );
	::DrawString( &Msg[0] );
// _nbg
	h += m_FontH;
	::MoveTo( m_FontW, h );
	sprintf( &cStr[0], "rgdwPOV[0] = %ld", pJs->rgdwPOV[0] );
	::c2pstrcpy( &Msg[0], &cStr[0] );
	::DrawString( &Msg[0] );
// {^
	int i;
	for ( i = 0; i < 8; i++ )
	{
		h += m_FontH;
		::MoveTo( m_FontW, h );
		sprintf( &cStr[0], "rgbButtons[%d] = 0x%02x", i, pJs->rgbButtons[i] );
		::c2pstrcpy( &Msg[0], &cStr[0] );
		::DrawString( &Msg[0] );
	}

	::SetGWorld( pGraf, hDev );

	m_Layer.Flush();
	Update();	// `XV
}
