//
//	MfMovie.cpp	: QuickTime Movie
//
//

#include "mfjundatta.h"

/*==================================================================*
 +
 +	CMfJundatta::MovieEvent	: Movie̍ĐʒůĎ
 +
 +==================================================================*/
void CMfJundatta::MovieEvent( void )
{
	// Movie͂邩H
	if ( m_Movie == NULL )	return;	// Ȃ

	// MovieĐ
	::MoviesTask( m_Movie, DoTheRightThing );

	// ĐI
	if ( ::IsMovieDone( m_Movie ) )
	{		// ĐI
		OnMovie( true );	// ĐIʒm
		return;
	}

	// rfIt[͎荞܂Ă邩
	if ( m_bMovieDraw == false )	return;	// 荞܂ĂȂ
		
	// 荞܂Ă
	m_bMovieDraw = false;
	OnMovie( false );	// Movie荞݊ʒm
}

/*==================================================================*
 +
 +	CMfJundatta::StartupMovie		: MoviẽX^[gAbv
 +	CMfJundatta::CleanupMovie		: MoviẽN[Abv
 +
 +==================================================================*/
// `抮ʒm
pascal OSErr CMfJundatta::MovieDrawProc( Movie movie, SInt32 refCon )
{
	CMfJundatta *p = (CMfJundatta *)refCon;

	p->m_bMovieDraw = true;
	return noErr;
}
bool CMfJundatta::StartupMovie( const FSSpec *pSpec )
{
	// t@CJ
	short resRefNum = 0;
	if ( ::OpenMovieFile( pSpec, &resRefNum, fsRdPerm ) != noErr )
	{
		return false;	// JȂ
	}
	// Movieo
	short resID = 0;
	::NewMovieFromFile( &m_Movie, resRefNum, &resID, NULL, newMovieActive, NULL );
	::CloseMovieFile( resRefNum );
	// 肾H
	if ( m_Movie == NULL )	return false;	// 肾Ȃ

	// Moviëʒu[
	Rect rcMovie;
	::GetMovieBox( m_Movie, &rcMovie );
	::OffsetRect( &rcMovie, -rcMovie.left, -rcMovie.top );

	m_bMovieDraw = false;	// Movie`抮tO

	// rfIt[͊܂܂ĂȂH
	if ( rcMovie.top == rcMovie.bottom )
	{		// ܂܂ĂȂ
		// ĐsȂ
		::StartMovie( m_Movie );
		return true;
	}

	m_VideoW = rcMovie.right;	// rfIt[̕
	m_VideoH = rcMovie.bottom;	// rfIt[̍
	::SetMovieBox( m_Movie, &rcMovie );

	// Movie荞GWorld쐬
	::QTNewGWorld( &m_pVideoGWorld,
		k32ARGBPixelFormat, &rcMovie, NULL, NULL, 0);
	if ( m_pVideoGWorld == NULL )
	{
		return false;	// s
	}
	
	// rfIt[󂯎obt@Ɛ̃oCgo
	::SetMovieGWorld( m_Movie, (CGrafPtr)m_pVideoGWorld, NULL );
	PixMapHandle hPixMap = ::GetGWorldPixMap( m_pVideoGWorld );
// QuickTimet[ނ߂ɂ炩LockPixels()Kv
	::LockPixels( hPixMap );

	// `抮R[obNo^
	m_MovieDrawUPP = ::NewMovieDrawingCompleteUPP( CMfJundatta::MovieDrawProc );
	::SetMovieDrawingCompleteProc( m_Movie,
                    movieDrawingCallWhenChanged, m_MovieDrawUPP, (SInt32)this );

	// Movie̍ĐJn
	::StartMovie( m_Movie );

	return true;
}
void CMfJundatta::CleanupMovie( void )
{
	// MovieȂ~
	if ( m_Movie != NULL )	::StopMovie( m_Movie );

	// `抮R[obNUPPj
	if ( m_MovieDrawUPP != NULL )
	{
		::DisposeMovieDrawingCompleteUPP( m_MovieDrawUPP );
		m_MovieDrawUPP = NULL;
		m_bMovieDraw = false;	// Movie`抮tO
	}

	// Movie荞GWorldj
	if ( m_pVideoGWorld != NULL )
	{
		PixMapHandle hPixMap = ::GetGWorldPixMap( m_pVideoGWorld );
		::UnlockPixels( hPixMap );
		::DisposeGWorld( m_pVideoGWorld );
		m_pVideoGWorld = NULL;
	}

	// Moviej
	if ( m_Movie != NULL )
	{
		::DisposeMovie( m_Movie );
		m_Movie = NULL;
		m_VideoW = 0;	// rfIt[̕
		m_VideoH = 0;	// rfIt[̍
	}
}
