//
//	MfBits.h	: Qc`
//
//

#ifndef _MFBITS_H_
#define _MFBITS_H_

/*==================================================================*
 +
 +	CMfBits::Startup		: Qcʂ𐶐
 +	CMfBits::Cleanup		: Qcʂj
 +	CMfBits::Clear			: Qcʂ
 +	CMfBits::Invert			: At@`l𔽓]
 +	CMfBits::GetOrigin		: Qcʂ̌_Wo
 +	CMfBits::Move			: Qcʂړ
 +	CMfBits::Flush			: GWorldeNX`ɃRs[
 +	CMfBits::Update			: QcʂXV
 +
 +==================================================================*/
class CMfBits
{
public:
	GWorldPtr				m_pGWorld;		// GWorld
	PixMapHandle			m_hPixMap;		// PixMap 0xaarrggbb
											// a = 0 : , 0xff : s
	UInt32					m_Pitch;		// ̃oCg

public:
	CMfBits();
	virtual ~CMfBits(){ Cleanup(); }

	bool Startup( UInt32 w, UInt32 h );
	void Cleanup( void );
	void Clear( UInt8 r, UInt8 g, UInt8 b, UInt8 a );	// a = 0 : , 0xff : s
	void Invert( void );
	void GetOrigin(
		int *pX,	// _xW
		int *pY,	// _yW
		float *pZ	// ʂ̐[ 0.0iOj ` -1.0ij
	)
	{
		*pX = m_OrgX;
		*pY = m_OrgY;
		*pZ = m_OrgZ;
	}
	void Move(
		int x,	// _xW
		int y,	// _yW
		float z		// ʂ̐[ 0.0iOj ` -1.0ij
	)
	{
		m_OrgX = x;
		m_OrgY = y;
		m_OrgZ = z;
	}
	void Flush( void );
	void Update( void );

private:
	GLubyte					*m_pTexture;	// eNX`

	UInt32					m_W;			// ʕ
	UInt32					m_H;			// ʍ

	UInt32					m_SurfaceW;		// eNX`
	UInt32					m_SurfaceH;		// eNX`

	UInt32					m_OrgX;			// _xW
	UInt32					m_OrgY;			// _yW
	float					m_OrgZ;			// ʂ̐[ 0.0iOj ` -1.0ij
};

#endif /* _MFBITS_H_ */
