//
//	player.cpp	: fBAĐvO
//
//

#include <math.h>
#include <stdio.h>
#include "mfjundatta.h"

class CPlayerJundatta : public CMfJundatta
{
private:
	CMfBits	m_Layer;		// 2D
	FSSpec	m_Spec;			// Đt@C
	
public:
	CPlayerJundatta();
	bool OnCreate( void );
	void OnDestroy( void );
	void OnMovie( bool bComplete );
	void OnUpdate( void );
	bool OnDropFile( const FSSpec *pSpec );
};


/*==================================================================*
 +
 +	MfStartupJundatta	: AvP[VX^[gAbv
 +
 +==================================================================*/
CMfJundatta *MfStartupJundatta( void )
{
	static CPlayerJundatta	sPlayerJundatta;
	char strCaption[80];
	sprintf( &strCaption[0], "fBAĐvO(200%s)", CMfJundatta::Version() );
	if ( sPlayerJundatta.Create( &strCaption[0], false ) == false )	return( NULL );
	return( &sPlayerJundatta );
}
CPlayerJundatta::CPlayerJundatta()
{
	memset( &m_Spec, 0, sizeof(m_Spec) );
}
bool CPlayerJundatta::OnCreate( void )
{
// 2Dʂ̐
	m_Layer.Startup( kMfScreenW, kMfScreenH );
	m_Layer.Clear( 0, 0, 0, 0xff );

	glDisable( GL_DEPTH_TEST );	// [xobt@O
	return true;
}
void CPlayerJundatta::OnDestroy( void )
{
	// 2Dʂ̔j
	m_Layer.Cleanup();
}
void CPlayerJundatta::OnMovie( bool bComplete )
{
	if ( bComplete != false )
	{
		// fBAĐ
		CleanupMovie();
		if ( StartupMovie( &m_Spec ) == false )
		{		// Đs
			CleanupMovie();
			return;
		}
	}

	// rfIt[LH
	if ( m_pVideoGWorld == NULL )	return;	// 

	// rfIt[2DʂɃRs[
	Rect srcRect, dstRect;
	::SetRect( &srcRect, 0, 0, m_VideoW, m_VideoH );
	::SetRect( &dstRect, 0, 0, kMfScreenW, kMfScreenH );
	::CopyBits( ::GetPortBitMapForCopyBits(m_pVideoGWorld),
				::GetPortBitMapForCopyBits(m_Layer.m_pGWorld),
				&srcRect, &dstRect, srcCopy, 0 );
	m_Layer.Flush();

	// ʂXV
	Update();
}
void CPlayerJundatta::OnUpdate( void )
{
	m_Layer.Update();
}
bool CPlayerJundatta::OnDropFile( const FSSpec *pSpec )
{
	// Đt@CL^
	m_Spec = *pSpec;

	// fBAĐ
	CleanupMovie();
	if ( StartupMovie( &m_Spec ) == false )
	{		// Đs
		CleanupMovie();
		return false;
	}

	return true;
}
